Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 9019)
@@ -5,26 +5,25 @@
    !!                   shelf
    !!======================================================================
-   !! History :  3.2   !  2011-02  (C.Harris  ) Original code isf cav
-   !!            X.X   !  2006-02  (C. Wang   ) Original code bg03
-   !!            3.4   !  2013-03  (P. Mathiot) Merging + parametrization
+   !! History :  3.2  !  2011-02  (C.Harris  ) Original code isf cav
+   !!            X.X  !  2006-02  (C. Wang   ) Original code bg03
+   !!            3.4  !  2013-03  (P. Mathiot) Merging + parametrization
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   sbc_isf        : update sbc under ice shelf
+   !!   sbc_isf       : update sbc under ice shelf
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE phycst          ! physical constants
-   USE eosbn2          ! equation of state
-   USE sbc_oce         ! surface boundary condition: ocean fields
-   USE zdfbfr          !
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE phycst         ! physical constants
+   USE eosbn2         ! equation of state
+   USE sbc_oce        ! surface boundary condition: ocean fields
+   USE zdfdrg         ! vertical physics: top/bottom drag coef.
    !
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
-   USE fldread         ! read input field at current time step
-   USE lbclnk          !
-   USE wrk_nemo        ! Memory allocation
-   USE timing          ! Timing
-   USE lib_fortran     ! glob_sum
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O library
+   USE fldread        ! read input field at current time step
+   USE lbclnk         !
+   USE timing         ! Timing
+   USE lib_fortran    ! glob_sum
 
    IMPLICIT NONE
@@ -35,6 +34,4 @@
    ! public in order to be able to output then 
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   risf_tsc_b, risf_tsc  !: before and now T & S isf contents [K.m/s & PSU.m/s]  
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   qisf                  !: net heat flux from ice shelf      [W/m2]
    REAL(wp), PUBLIC ::   rn_hisf_tbl                 !: thickness of top boundary layer [m]
    INTEGER , PUBLIC ::   nn_isf                      !: flag to choose between explicit/param/specified  
@@ -44,19 +41,21 @@
    REAL(wp), PUBLIC ::   rn_gammas0                  !: salinity    exchange coeficient []
 
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  rzisf_tbl              !:depth of calving front (shallowest point) nn_isf ==2/3
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  rhisf_tbl, rhisf_tbl_0 !:thickness of tbl  [m]
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  r1_hisf_tbl            !:1/thickness of tbl
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  ralpha                 !:proportion of bottom cell influenced by tbl 
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  risfLeff               !:effective length (Leff) BG03 nn_isf==2
-   REAL(wp)   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)     ::  ttbl, stbl, utbl, vtbl !:top boundary layer variable at T point
-   INTEGER,    PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:)      ::  misfkt, misfkb         !:Level of ice shelf base
-
-   LOGICAL, PUBLIC ::   l_isfcpl = .false.       ! isf recieved from oasis
-
-   REAL(wp), PUBLIC, SAVE ::   rcpi     = 2000.0_wp     ! specific heat of ice shelf             [J/kg/K]
-   REAL(wp), PUBLIC, SAVE ::   rkappa   = 1.54e-6_wp    ! heat diffusivity through the ice-shelf [m2/s]
-   REAL(wp), PUBLIC, SAVE ::   rhoisf   = 920.0_wp      ! volumic mass of ice shelf              [kg/m3]
-   REAL(wp), PUBLIC, SAVE ::   tsurf    = -20.0_wp      ! air temperature on top of ice shelf    [C]
-   REAL(wp), PUBLIC, SAVE ::   rlfusisf = 0.334e6_wp    ! latent heat of fusion of ice shelf     [J/kg]
+   INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   misfkt   , misfkb        !: Level of ice shelf base
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rzisf_tbl                !: depth of calving front (shallowest point) nn_isf ==2/3
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rhisf_tbl, rhisf_tbl_0   !: thickness of tbl  [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   r1_hisf_tbl              !: 1/thickness of tbl
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ralpha                   !: proportion of bottom cell influenced by tbl 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   risfLeff                 !: effective length (Leff) BG03 nn_isf==2
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ttbl, stbl, utbl, vtbl   !: top boundary layer variable at T point
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   qisf                     !: net heat flux from ice shelf      [W/m2]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   risf_tsc_b, risf_tsc     !: before and now T & S isf contents [K.m/s & PSU.m/s]  
+
+   LOGICAL, PUBLIC ::   l_isfcpl = .false.       !: isf recieved from oasis
+
+   REAL(wp), PUBLIC, SAVE ::   rcpi     = 2000.0_wp     !: specific heat of ice shelf             [J/kg/K]
+   REAL(wp), PUBLIC, SAVE ::   rkappa   = 1.54e-6_wp    !: heat diffusivity through the ice-shelf [m2/s]
+   REAL(wp), PUBLIC, SAVE ::   rhoisf   = 920.0_wp      !: volumic mass of ice shelf              [kg/m3]
+   REAL(wp), PUBLIC, SAVE ::   tsurf    = -20.0_wp      !: air temperature on top of ice shelf    [C]
+   REAL(wp), PUBLIC, SAVE ::   rlfusisf = 0.334e6_wp    !: latent heat of fusion of ice shelf     [J/kg]
 
 !: Variable used in fldread to read the forcing file (nn_isf == 4 .OR. nn_isf == 3)
@@ -71,5 +70,5 @@
    
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , LOCEAN-IPSL (2015)
+   !! NEMO/OPA 4.0 , LOCEAN-IPSL (2017)
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -77,5 +76,5 @@
 CONTAINS
  
-  SUBROUTINE sbc_isf(kt)
+  SUBROUTINE sbc_isf( kt )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE sbc_isf  ***
@@ -90,18 +89,15 @@
       !!                        4 : specified fwf and heat flux forcing beneath the ice shelf
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) :: kt                   ! ocean time step
-      !
-      INTEGER               :: ji, jj, jk           ! loop index
-      INTEGER               :: ikt, ikb             ! loop index
-      REAL(wp), DIMENSION (:,:), POINTER :: zt_frz, zdep ! freezing temperature (zt_frz) at depth (zdep) 
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zfwfisf3d, zqhcisf3d, zqlatisf3d
-      REAL(wp), DIMENSION(:,:  ), POINTER :: zqhcisf2d
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
+      !
+      INTEGER ::   ji, jj, jk   ! loop index
+      INTEGER ::   ikt, ikb     ! local integers
+      REAL(wp), DIMENSION(jpi,jpj) ::   zt_frz, zdep   ! freezing temperature (zt_frz) at depth (zdep) 
+      REAL(wp), DIMENSION(:,:)  , ALLOCATABLE ::   zqhcisf2d
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   zfwfisf3d, zqhcisf3d, zqlatisf3d
       !!---------------------------------------------------------------------
       !
-      IF( MOD( kt-1, nn_fsbc) == 0 ) THEN
-         ! allocation
-         CALL wrk_alloc( jpi,jpj, zt_frz, zdep  )
-
-         ! compute salt and heat flux
+      IF( MOD( kt-1, nn_fsbc) == 0 ) THEN    ! compute salt and heat flux
+         !
          SELECT CASE ( nn_isf )
          CASE ( 1 )    ! realistic ice shelf formulation
@@ -121,9 +117,9 @@
             ELSE                        ;   qisf(:,:)  = fwfisf(:,:) * rlfusisf  ! heat        flux
             ENDIF
-
+            !
          CASE ( 2 )    ! Beckmann and Goosse parametrisation 
             stbl(:,:)   = soce
             CALL sbc_isf_bg03(kt)
-
+            !
          CASE ( 3 )    ! specified runoff in depth (Mathiot et al., XXXX in preparation)
             ! specified runoff in depth (Mathiot et al., XXXX in preparation)
@@ -134,7 +130,7 @@
             qisf(:,:)   = fwfisf(:,:) * rlfusisf             ! heat flux
             stbl(:,:)   = soce
-
+            !
          CASE ( 4 )    ! specified fwf and heat flux forcing beneath the ice shelf
-           ! specified fwf and heat flux forcing beneath the ice shelf
+            !          ! specified fwf and heat flux forcing beneath the ice shelf
             IF( .NOT.l_isfcpl ) THEN
                CALL fld_read ( kt, nn_fsbc, sf_fwfisf   )
@@ -144,5 +140,5 @@
             qisf(:,:)   = fwfisf(:,:) * rlfusisf               ! heat flux
             stbl(:,:)   = soce
-
+            !
          END SELECT
 
@@ -162,8 +158,8 @@
 
          ! lbclnk
-         CALL lbc_lnk(risf_tsc(:,:,jp_tem),'T',1.)
-         CALL lbc_lnk(risf_tsc(:,:,jp_sal),'T',1.)
-         CALL lbc_lnk(fwfisf(:,:)   ,'T',1.)
-         CALL lbc_lnk(qisf(:,:)     ,'T',1.)
+         CALL lbc_lnk( risf_tsc(:,:,jp_tem),'T',1.)
+         CALL lbc_lnk( risf_tsc(:,:,jp_sal),'T',1.)
+         CALL lbc_lnk( fwfisf  (:,:)       ,'T',1.)
+         CALL lbc_lnk( qisf    (:,:)       ,'T',1.)
 
          ! output
@@ -173,14 +169,14 @@
          IF( iom_use('fwfisf'  ) )       CALL iom_put( 'fwfisf'      , fwfisf(:,:)                       )   ! isf mass flux (opposite sign)
 
-        ! Diagnostics
-        IF ( iom_use('fwfisf3d') .OR. iom_use('qlatisf3d') .OR. iom_use('qhcisf3d') .OR. iom_use('qhcisf')) THEN
-            CALL wrk_alloc( jpi,jpj,jpk, zfwfisf3d, zqhcisf3d, zqlatisf3d )
-            CALL wrk_alloc( jpi,jpj,     zqhcisf2d                        )
-
-            zfwfisf3d(:,:,:) = 0.0_wp                         ! 3d ice shelf melting (kg/m2/s)
-            zqhcisf3d(:,:,:) = 0.0_wp                         ! 3d heat content flux (W/m2)
-            zqlatisf3d(:,:,:)= 0.0_wp                         ! 3d ice shelf melting latent heat flux (W/m2)
-            zqhcisf2d(:,:)   = fwfisf(:,:) * zt_frz * rcp     ! 2d heat content flux (W/m2)
-
+         ! Diagnostics
+         IF( iom_use('fwfisf3d') .OR. iom_use('qlatisf3d') .OR. iom_use('qhcisf3d') .OR. iom_use('qhcisf')) THEN
+            ALLOCATE( zfwfisf3d(jpi,jpj,jpk) , zqhcisf3d(jpi,jpj,jpk) , zqlatisf3d(jpi,jpj,jpk) )
+            ALLOCATE( zqhcisf2d(jpi,jpj) )
+            !
+            zfwfisf3d (:,:,:) = 0._wp                         ! 3d ice shelf melting (kg/m2/s)
+            zqhcisf3d (:,:,:) = 0._wp                         ! 3d heat content flux (W/m2)
+            zqlatisf3d(:,:,:) = 0._wp                         ! 3d ice shelf melting latent heat flux (W/m2)
+            zqhcisf2d (:,:)   = fwfisf(:,:) * zt_frz * rcp    ! 2d heat content flux (W/m2)
+            !
             DO jj = 1,jpj
                DO ji = 1,jpi
@@ -200,45 +196,43 @@
                END DO
             END DO
-
+            !
             CALL iom_put('fwfisf3d' , zfwfisf3d (:,:,:))
             CALL iom_put('qlatisf3d', zqlatisf3d(:,:,:))
             CALL iom_put('qhcisf3d' , zqhcisf3d (:,:,:))
             CALL iom_put('qhcisf'   , zqhcisf2d (:,:  ))
-
-            CALL wrk_dealloc( jpi,jpj,jpk, zfwfisf3d, zqhcisf3d, zqlatisf3d )
-            CALL wrk_dealloc( jpi,jpj,     zqhcisf2d                        )
-          END IF
-          ! deallocation
-          CALL wrk_dealloc( jpi,jpj, zt_frz, zdep  )
-          !
-        END IF
-
-        IF( kt == nit000 ) THEN                         !   set the forcing field at nit000 - 1    !
-           IF( ln_rstart .AND.    &                     ! Restart: read in restart file
-                 & iom_varid( numror, 'fwf_isf_b', ldstop = .FALSE. ) > 0 ) THEN
-               IF(lwp) WRITE(numout,*) '          nit000-1 isf tracer content forcing fields read in the restart file'
-               CALL iom_get( numror, jpdom_autoglo, 'fwf_isf_b', fwfisf_b(:,:) )   ! before salt content isf_tsc trend
-               CALL iom_get( numror, jpdom_autoglo, 'isf_sc_b', risf_tsc_b(:,:,jp_sal) )   ! before salt content isf_tsc trend
-               CALL iom_get( numror, jpdom_autoglo, 'isf_hc_b', risf_tsc_b(:,:,jp_tem) )   ! before salt content isf_tsc trend
-           ELSE
-               fwfisf_b(:,:)    = fwfisf(:,:)
-               risf_tsc_b(:,:,:)= risf_tsc(:,:,:)
-           END IF
-         END IF
-         ! 
-         IF( lrst_oce ) THEN
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) 'sbc : isf surface tracer content forcing fields written in ocean restart file ',   &
-               &                    'at it= ', kt,' date= ', ndastp
-            IF(lwp) WRITE(numout,*) '~~~~'
-            CALL iom_rstput( kt, nitrst, numrow, 'fwf_isf_b', fwfisf(:,:) )
-            CALL iom_rstput( kt, nitrst, numrow, 'isf_hc_b' , risf_tsc(:,:,jp_tem) )
-            CALL iom_rstput( kt, nitrst, numrow, 'isf_sc_b' , risf_tsc(:,:,jp_sal) )
+            !
+            DEALLOCATE( zfwfisf3d, zqhcisf3d, zqlatisf3d )
+            DEALLOCATE( zqhcisf2d )
          ENDIF
          !
-  END SUBROUTINE sbc_isf
-
-
-  INTEGER FUNCTION sbc_isf_alloc()
+      ENDIF
+
+      IF( kt == nit000 ) THEN                         !   set the forcing field at nit000 - 1    !
+         IF( ln_rstart .AND.    &                     ! Restart: read in restart file
+            &   iom_varid( numror, 'fwf_isf_b', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nit000-1 isf tracer content forcing fields read in the restart file'
+            CALL iom_get( numror, jpdom_autoglo, 'fwf_isf_b', fwfisf_b(:,:) )   ! before salt content isf_tsc trend
+            CALL iom_get( numror, jpdom_autoglo, 'isf_sc_b', risf_tsc_b(:,:,jp_sal) )   ! before salt content isf_tsc trend
+            CALL iom_get( numror, jpdom_autoglo, 'isf_hc_b', risf_tsc_b(:,:,jp_tem) )   ! before salt content isf_tsc trend
+         ELSE
+            fwfisf_b(:,:)    = fwfisf(:,:)
+            risf_tsc_b(:,:,:)= risf_tsc(:,:,:)
+         ENDIF
+      ENDIF
+      ! 
+      IF( lrst_oce ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'sbc : isf surface tracer content forcing fields written in ocean restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         CALL iom_rstput( kt, nitrst, numrow, 'fwf_isf_b', fwfisf(:,:) )
+         CALL iom_rstput( kt, nitrst, numrow, 'isf_hc_b' , risf_tsc(:,:,jp_tem) )
+         CALL iom_rstput( kt, nitrst, numrow, 'isf_sc_b' , risf_tsc(:,:,jp_sal) )
+      ENDIF
+      !
+   END SUBROUTINE sbc_isf
+
+
+   INTEGER FUNCTION sbc_isf_alloc()
       !!----------------------------------------------------------------------
       !!               ***  FUNCTION sbc_isf_rnf_alloc  ***
@@ -256,6 +250,7 @@
          IF( sbc_isf_alloc /= 0 )   CALL ctl_warn('sbc_isf_alloc: failed to allocate arrays.')
          !
-      END IF
-  END FUNCTION
+      ENDIF
+   END FUNCTION
+
 
   SUBROUTINE sbc_isf_init
@@ -294,8 +289,6 @@
 
       IF ( lwp ) WRITE(numout,*)
-      IF ( lwp ) WRITE(numout,*) 'sbc_isf: heat flux of the ice shelf'
-      IF ( lwp ) WRITE(numout,*) '~~~~~~~~~'
-      IF ( lwp ) WRITE(numout,*) 'sbcisf :' 
-      IF ( lwp ) WRITE(numout,*) '~~~~~~~~'
+      IF ( lwp ) WRITE(numout,*) 'sbc_isf_init : heat flux of the ice shelf'
+      IF ( lwp ) WRITE(numout,*) '~~~~~~~~~~~'
       IF ( lwp ) WRITE(numout,*) '        nn_isf      = ', nn_isf
       IF ( lwp ) WRITE(numout,*) '        nn_isfblk   = ', nn_isfblk
@@ -304,5 +297,5 @@
       IF ( lwp ) WRITE(numout,*) '        rn_gammat0  = ', rn_gammat0  
       IF ( lwp ) WRITE(numout,*) '        rn_gammas0  = ', rn_gammas0  
-      IF ( lwp ) WRITE(numout,*) '        rn_tfri2    = ', rn_tfri2 
+      IF ( lwp ) WRITE(numout,*) '        rn_Cd0      = ', r_Cdmin_top 
       !
       ! Allocate public variable
@@ -310,6 +303,6 @@
       !
       ! initialisation
-      qisf(:,:)        = 0._wp  ; fwfisf  (:,:) = 0._wp
-      risf_tsc(:,:,:)  = 0._wp  ; fwfisf_b(:,:) = 0._wp
+      qisf    (:,:)    = 0._wp   ;   fwfisf  (:,:) = 0._wp
+      risf_tsc(:,:,:)  = 0._wp   ;   fwfisf_b(:,:) = 0._wp
       !
       ! define isf tbl tickness, top and bottom indice
@@ -317,5 +310,5 @@
       CASE ( 1 ) 
          rhisf_tbl(:,:) = rn_hisf_tbl
-         misfkt(:,:)    = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
+         misfkt   (:,:) = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
 
       CASE ( 2 , 3 )
@@ -351,4 +344,5 @@
             DO jj = 1, jpj
                 ik = 2
+!!gm potential bug: use gdepw_0 not _n
                 DO WHILE ( ik <= mbkt(ji,jj) .AND. gdepw_n(ji,jj,ik) < rzisf_tbl(ji,jj) ) ;  ik = ik + 1 ;  END DO
                 misfkt(ji,jj) = ik-1
@@ -359,5 +353,5 @@
          ! as in nn_isf == 1
          rhisf_tbl(:,:) = rn_hisf_tbl
-         misfkt(:,:)    = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
+         misfkt   (:,:) = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
          
          ! load variable used in fldread (use for temporal interpolation of isf fwf forcing)
@@ -382,5 +376,5 @@
             ! determine the deepest level influenced by the boundary layer
             DO jk = ikt+1, mbkt(ji,jj)
-               IF ( (SUM(e3t_n(ji,jj,ikt:jk-1)) < rhisf_tbl(ji,jj)) .AND. (tmask(ji,jj,jk) == 1) ) ikb = jk
+               IF( (SUM(e3t_n(ji,jj,ikt:jk-1)) < rhisf_tbl(ji,jj)) .AND. (tmask(ji,jj,jk) == 1) )   ikb = jk
             END DO
             rhisf_tbl(ji,jj) = MIN(rhisf_tbl(ji,jj), SUM(e3t_n(ji,jj,ikt:ikb))) ! limit the tbl to water thickness.
@@ -395,4 +389,5 @@
   END SUBROUTINE sbc_isf_init
 
+
   SUBROUTINE sbc_isf_bg03(kt)
       !!---------------------------------------------------------------------
@@ -407,6 +402,5 @@
       !!         interaction for climate models", Ocean Modelling 5(2003) 157-170.
       !!         (hereafter BG)
-      !! History :
-      !!         06-02  (C. Wang) Original code
+      !! History :  06-02  (C. Wang) Original code
       !!----------------------------------------------------------------------
       INTEGER, INTENT ( in ) :: kt
@@ -420,5 +414,5 @@
       !!----------------------------------------------------------------------
 
-      IF ( nn_timing == 1 ) CALL timing_start('sbc_isf_bg03')
+      IF( nn_timing == 1 )   CALL timing_start('sbc_isf_bg03')
       !
       DO ji = 1, jpi
@@ -446,12 +440,13 @@
                !add to salinity trend
             ELSE
-               qisf(ji,jj) = 0._wp ; fwfisf(ji,jj) = 0._wp
+               qisf(ji,jj) = 0._wp   ;   fwfisf(ji,jj) = 0._wp
             END IF
          END DO
       END DO
       !
-      IF( nn_timing == 1 )  CALL timing_stop('sbc_isf_bg03')
+      IF( nn_timing == 1 )   CALL timing_stop('sbc_isf_bg03')
       !
   END SUBROUTINE sbc_isf_bg03
+
 
   SUBROUTINE sbc_isf_cav( kt )
@@ -468,8 +463,9 @@
       !!                emp, emps  : update freshwater flux below ice shelf
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in)          ::   kt         ! ocean time step
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
       !
       INTEGER  ::   ji, jj     ! dummy loop indices
       INTEGER  ::   nit
+      LOGICAL  ::   lit
       REAL(wp) ::   zlamb1, zlamb2, zlamb3
       REAL(wp) ::   zeps1,zeps2,zeps3,zeps4,zeps6,zeps7
@@ -477,8 +473,7 @@
       REAL(wp) ::   zeps = 1.e-20_wp        
       REAL(wp) ::   zerr
-      REAL(wp), DIMENSION(:,:), POINTER ::   zfrz
-      REAL(wp), DIMENSION(:,:), POINTER ::   zgammat, zgammas 
-      REAL(wp), DIMENSION(:,:), POINTER ::   zfwflx, zhtflx, zhtflx_b
-      LOGICAL  ::   lit
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfrz
+      REAL(wp), DIMENSION(jpi,jpj) ::   zgammat, zgammas 
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfwflx, zhtflx, zhtflx_b
       !!---------------------------------------------------------------------
       ! coeficient for linearisation of potential tfreez
@@ -489,7 +484,4 @@
       IF( nn_timing == 1 )  CALL timing_start('sbc_isf_cav')
       !
-      CALL wrk_alloc( jpi,jpj, zfrz  , zgammat, zgammas  )
-      CALL wrk_alloc( jpi,jpj, zfwflx, zhtflx , zhtflx_b )
-
       ! initialisation
       zgammat(:,:) = rn_gammat0 ; zgammas (:,:) = rn_gammas0
@@ -583,7 +575,4 @@
       CALL iom_put('isfgammas', zgammas)
       ! 
-      CALL wrk_dealloc( jpi,jpj, zfrz  , zgammat, zgammas  )
-      CALL wrk_dealloc( jpi,jpj, zfwflx, zhtflx , zhtflx_b )
-      !
       IF( nn_timing == 1 )  CALL timing_stop('sbc_isf_cav')
       !
@@ -605,5 +594,4 @@
       INTEGER  :: ikt                        
       INTEGER  :: ji, jj                     ! loop index
-      REAL(wp), DIMENSION(:,:), POINTER :: zustar           ! U, V at T point and friction velocity
       REAL(wp) :: zdku, zdkv                 ! U, V shear 
       REAL(wp) :: zPr, zSc, zRc              ! Prandtl, Scmidth and Richardson number 
@@ -619,6 +607,6 @@
       REAL(wp), PARAMETER :: znu   = 1.95e-6_wp ! kinamatic viscosity of sea water (m2.s-1)
       REAL(wp), DIMENSION(2) :: zts, zab
+      REAL(wp), DIMENSION(jpi,jpj) :: zustar   ! U, V at T point and friction velocity
       !!---------------------------------------------------------------------
-      CALL wrk_alloc( jpi,jpj, zustar )
       !
       SELECT CASE ( nn_gammablk )
@@ -631,7 +619,9 @@
          !! Jenkins et al., 2010, JPO, p2298-2312
          !! Adopted by Asay-Davis et al. (2015)
-
-         !! compute ustar (eq. 24)
-         zustar(:,:) = SQRT( rn_tfri2 * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + rn_tfeb2) )
+!!gm  I don't understand the u* expression in those papers... (see for example zdfglf module)
+!!    for me ustar= Cd0 * |U|  not  (Cd0)^1/2 * |U| ....  which is what you can find in Jenkins et al.
+
+         !! compute ustar (eq. 24)           !! NB: here r_Cdmin_top = rn_Cd0 read in namdrg_top namelist)
+         zustar(:,:) = SQRT( r_Cdmin_top * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + r_ke0_top) )
 
          !! Compute gammats
@@ -643,5 +633,5 @@
          !! as MOL depends of flux and flux depends of MOL, best will be iteration (TO DO)
          !! compute ustar
-         zustar(:,:) = SQRT( rn_tfri2 * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + rn_tfeb2) )
+         zustar(:,:) = SQRT( r_Cdmin_top * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + r_ke0_top) )
 
          !! compute Pr and Sc number (can be improved)
@@ -654,13 +644,15 @@
 
          !! compute gamma
-         DO ji=2,jpi
-            DO jj=2,jpj
+         DO ji = 2, jpi
+            DO jj = 2, jpj
                ikt = mikt(ji,jj)
 
-               IF (zustar(ji,jj) == 0._wp) THEN           ! only for kt = 1 I think
+               IF( zustar(ji,jj) == 0._wp ) THEN           ! only for kt = 1 I think
                   pgt = rn_gammat0
                   pgs = rn_gammas0
                ELSE
                   !! compute Rc number (as done in zdfric.F90)
+!!gm better to do it like in the new zdfric.F90   i.e. avm weighted Ri computation
+!!gm moreover, use Max(rn2,0) to take care of static instabilities....
                   zcoef = 0.5_wp / e3w_n(ji,jj,ikt)
                   !                                            ! shear of horizontal velocity
@@ -708,8 +700,8 @@
          CALL lbc_lnk(pgs(:,:),'T',1.)
       END SELECT
-      CALL wrk_dealloc( jpi,jpj, zustar )
       !
    END SUBROUTINE sbc_isf_gammats
 
+
    SUBROUTINE sbc_isf_tbl( pvarin, pvarout, cd_ptin )
       !!----------------------------------------------------------------------
@@ -719,16 +711,13 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:,:), INTENT( in  ) :: pvarin
-      REAL(wp), DIMENSION(:,:)  , INTENT( out ) :: pvarout
-      CHARACTER(len=1),           INTENT( in  ) :: cd_ptin ! point of variable in/out
-      !
-      REAL(wp) :: ze3, zhk
-      REAL(wp), DIMENSION(:,:), POINTER :: zhisf_tbl ! thickness of the tbl
-
-      INTEGER :: ji, jj, jk                  ! loop index
-      INTEGER :: ikt, ikb                    ! top and bottom index of the tbl
-      !!----------------------------------------------------------------------
-      ! allocation
-      CALL wrk_alloc( jpi,jpj, zhisf_tbl)
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) :: pvarin
+      REAL(wp), DIMENSION(:,:)  , INTENT(  out) :: pvarout
+      CHARACTER(len=1),           INTENT(in   ) :: cd_ptin ! point of variable in/out
+      !
+      INTEGER ::   ji, jj, jk                ! loop index
+      INTEGER ::   ikt, ikb                    ! top and bottom index of the tbl
+      REAL(wp) ::   ze3, zhk
+      REAL(wp), DIMENSION(jpi,jpj) :: zhisf_tbl ! thickness of the tbl
+      !!----------------------------------------------------------------------
       
       ! initialisation
@@ -741,5 +730,5 @@
                ikt = miku(ji,jj) ; ikb = miku(ji,jj)
                ! thickness of boundary layer at least the top level thickness
-               zhisf_tbl(ji,jj) = MAX(rhisf_tbl_0(ji,jj), e3u_n(ji,jj,ikt))
+               zhisf_tbl(ji,jj) = MAX( rhisf_tbl_0(ji,jj) , e3u_n(ji,jj,ikt) )
 
                ! determine the deepest level influenced by the boundary layer
@@ -760,6 +749,7 @@
             END DO
          END DO
-         DO jj = 2,jpj
-            DO ji = 2,jpi
+         DO jj = 2, jpj
+            DO ji = 2, jpi
+!!gm a wet-point only average should be used here !!!
                pvarout(ji,jj) = 0.5_wp * (pvarout(ji,jj) + pvarout(ji-1,jj))
             END DO
@@ -791,6 +781,7 @@
             END DO
          END DO
-         DO jj = 2,jpj
-            DO ji = 2,jpi
+         DO jj = 2, jpj
+            DO ji = 2, jpi
+!!gm a wet-point only average should be used here !!!
                pvarout(ji,jj) = 0.5_wp * (pvarout(ji,jj) + pvarout(ji,jj-1))
             END DO
@@ -816,10 +807,7 @@
          END DO
       END SELECT
-
+      !
       ! mask mean tbl value
       pvarout(:,:) = pvarout(:,:) * ssmask(:,:)
-
-      ! deallocation
-      CALL wrk_dealloc( jpi,jpj, zhisf_tbl )      
       !
    END SUBROUTINE sbc_isf_tbl
@@ -887,4 +875,5 @@
       !
    END SUBROUTINE sbc_isf_div
+
    !!======================================================================
 END MODULE sbcisf
